/*
Copyright 2020 The Flux authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1beta1

import (
	"context"

	v1beta1 "github.com/fluxcd/flagger/pkg/apis/appmesh/v1beta1"
	scheme "github.com/fluxcd/flagger/pkg/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	gentype "k8s.io/client-go/gentype"
)

// MeshesGetter has a method to return a MeshInterface.
// A group's client should implement this interface.
type MeshesGetter interface {
	Meshes() MeshInterface
}

// MeshInterface has methods to work with Mesh resources.
type MeshInterface interface {
	Create(ctx context.Context, mesh *v1beta1.Mesh, opts v1.CreateOptions) (*v1beta1.Mesh, error)
	Update(ctx context.Context, mesh *v1beta1.Mesh, opts v1.UpdateOptions) (*v1beta1.Mesh, error)
	// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
	UpdateStatus(ctx context.Context, mesh *v1beta1.Mesh, opts v1.UpdateOptions) (*v1beta1.Mesh, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1beta1.Mesh, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1beta1.MeshList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.Mesh, err error)
	MeshExpansion
}

// meshes implements MeshInterface
type meshes struct {
	*gentype.ClientWithList[*v1beta1.Mesh, *v1beta1.MeshList]
}

// newMeshes returns a Meshes
func newMeshes(c *AppmeshV1beta1Client) *meshes {
	return &meshes{
		gentype.NewClientWithList[*v1beta1.Mesh, *v1beta1.MeshList](
			"meshes",
			c.RESTClient(),
			scheme.ParameterCodec,
			"",
			func() *v1beta1.Mesh { return &v1beta1.Mesh{} },
			func() *v1beta1.MeshList { return &v1beta1.MeshList{} }),
	}
}
