/*
Copyright 2020 The Flux authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1beta2

import (
	"context"

	v1beta2 "github.com/fluxcd/flagger/pkg/apis/appmesh/v1beta2"
	scheme "github.com/fluxcd/flagger/pkg/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	gentype "k8s.io/client-go/gentype"
)

// VirtualRoutersGetter has a method to return a VirtualRouterInterface.
// A group's client should implement this interface.
type VirtualRoutersGetter interface {
	VirtualRouters(namespace string) VirtualRouterInterface
}

// VirtualRouterInterface has methods to work with VirtualRouter resources.
type VirtualRouterInterface interface {
	Create(ctx context.Context, virtualRouter *v1beta2.VirtualRouter, opts v1.CreateOptions) (*v1beta2.VirtualRouter, error)
	Update(ctx context.Context, virtualRouter *v1beta2.VirtualRouter, opts v1.UpdateOptions) (*v1beta2.VirtualRouter, error)
	// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
	UpdateStatus(ctx context.Context, virtualRouter *v1beta2.VirtualRouter, opts v1.UpdateOptions) (*v1beta2.VirtualRouter, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1beta2.VirtualRouter, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1beta2.VirtualRouterList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta2.VirtualRouter, err error)
	VirtualRouterExpansion
}

// virtualRouters implements VirtualRouterInterface
type virtualRouters struct {
	*gentype.ClientWithList[*v1beta2.VirtualRouter, *v1beta2.VirtualRouterList]
}

// newVirtualRouters returns a VirtualRouters
func newVirtualRouters(c *AppmeshV1beta2Client, namespace string) *virtualRouters {
	return &virtualRouters{
		gentype.NewClientWithList[*v1beta2.VirtualRouter, *v1beta2.VirtualRouterList](
			"virtualrouters",
			c.RESTClient(),
			scheme.ParameterCodec,
			namespace,
			func() *v1beta2.VirtualRouter { return &v1beta2.VirtualRouter{} },
			func() *v1beta2.VirtualRouterList { return &v1beta2.VirtualRouterList{} }),
	}
}
