/*
Copyright 2020 The Flux authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1beta1

import (
	v1beta1 "github.com/fluxcd/flagger/pkg/apis/flagger/v1beta1"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/listers"
	"k8s.io/client-go/tools/cache"
)

// AlertProviderLister helps list AlertProviders.
// All objects returned here must be treated as read-only.
type AlertProviderLister interface {
	// List lists all AlertProviders in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta1.AlertProvider, err error)
	// AlertProviders returns an object that can list and get AlertProviders.
	AlertProviders(namespace string) AlertProviderNamespaceLister
	AlertProviderListerExpansion
}

// alertProviderLister implements the AlertProviderLister interface.
type alertProviderLister struct {
	listers.ResourceIndexer[*v1beta1.AlertProvider]
}

// NewAlertProviderLister returns a new AlertProviderLister.
func NewAlertProviderLister(indexer cache.Indexer) AlertProviderLister {
	return &alertProviderLister{listers.New[*v1beta1.AlertProvider](indexer, v1beta1.Resource("alertprovider"))}
}

// AlertProviders returns an object that can list and get AlertProviders.
func (s *alertProviderLister) AlertProviders(namespace string) AlertProviderNamespaceLister {
	return alertProviderNamespaceLister{listers.NewNamespaced[*v1beta1.AlertProvider](s.ResourceIndexer, namespace)}
}

// AlertProviderNamespaceLister helps list and get AlertProviders.
// All objects returned here must be treated as read-only.
type AlertProviderNamespaceLister interface {
	// List lists all AlertProviders in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta1.AlertProvider, err error)
	// Get retrieves the AlertProvider from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1beta1.AlertProvider, error)
	AlertProviderNamespaceListerExpansion
}

// alertProviderNamespaceLister implements the AlertProviderNamespaceLister
// interface.
type alertProviderNamespaceLister struct {
	listers.ResourceIndexer[*v1beta1.AlertProvider]
}
