/*
Copyright 2020 The Flux authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1

import (
	v1 "github.com/fluxcd/flagger/pkg/apis/gloogateway/v1"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/listers"
	"k8s.io/client-go/tools/cache"
)

// RouteTableLister helps list RouteTables.
// All objects returned here must be treated as read-only.
type RouteTableLister interface {
	// List lists all RouteTables in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1.RouteTable, err error)
	// RouteTables returns an object that can list and get RouteTables.
	RouteTables(namespace string) RouteTableNamespaceLister
	RouteTableListerExpansion
}

// routeTableLister implements the RouteTableLister interface.
type routeTableLister struct {
	listers.ResourceIndexer[*v1.RouteTable]
}

// NewRouteTableLister returns a new RouteTableLister.
func NewRouteTableLister(indexer cache.Indexer) RouteTableLister {
	return &routeTableLister{listers.New[*v1.RouteTable](indexer, v1.Resource("routetable"))}
}

// RouteTables returns an object that can list and get RouteTables.
func (s *routeTableLister) RouteTables(namespace string) RouteTableNamespaceLister {
	return routeTableNamespaceLister{listers.NewNamespaced[*v1.RouteTable](s.ResourceIndexer, namespace)}
}

// RouteTableNamespaceLister helps list and get RouteTables.
// All objects returned here must be treated as read-only.
type RouteTableNamespaceLister interface {
	// List lists all RouteTables in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1.RouteTable, err error)
	// Get retrieves the RouteTable from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1.RouteTable, error)
	RouteTableNamespaceListerExpansion
}

// routeTableNamespaceLister implements the RouteTableNamespaceLister
// interface.
type routeTableNamespaceLister struct {
	listers.ResourceIndexer[*v1.RouteTable]
}
