/*
Copyright 2020 The Flux authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1

import (
	v1 "github.com/fluxcd/flagger/pkg/apis/projectcontour/v1"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/listers"
	"k8s.io/client-go/tools/cache"
)

// HTTPProxyLister helps list HTTPProxies.
// All objects returned here must be treated as read-only.
type HTTPProxyLister interface {
	// List lists all HTTPProxies in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1.HTTPProxy, err error)
	// HTTPProxies returns an object that can list and get HTTPProxies.
	HTTPProxies(namespace string) HTTPProxyNamespaceLister
	HTTPProxyListerExpansion
}

// hTTPProxyLister implements the HTTPProxyLister interface.
type hTTPProxyLister struct {
	listers.ResourceIndexer[*v1.HTTPProxy]
}

// NewHTTPProxyLister returns a new HTTPProxyLister.
func NewHTTPProxyLister(indexer cache.Indexer) HTTPProxyLister {
	return &hTTPProxyLister{listers.New[*v1.HTTPProxy](indexer, v1.Resource("httpproxy"))}
}

// HTTPProxies returns an object that can list and get HTTPProxies.
func (s *hTTPProxyLister) HTTPProxies(namespace string) HTTPProxyNamespaceLister {
	return hTTPProxyNamespaceLister{listers.NewNamespaced[*v1.HTTPProxy](s.ResourceIndexer, namespace)}
}

// HTTPProxyNamespaceLister helps list and get HTTPProxies.
// All objects returned here must be treated as read-only.
type HTTPProxyNamespaceLister interface {
	// List lists all HTTPProxies in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1.HTTPProxy, err error)
	// Get retrieves the HTTPProxy from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1.HTTPProxy, error)
	HTTPProxyNamespaceListerExpansion
}

// hTTPProxyNamespaceLister implements the HTTPProxyNamespaceLister
// interface.
type hTTPProxyNamespaceLister struct {
	listers.ResourceIndexer[*v1.HTTPProxy]
}
