/*
Copyright 2020 The Flux authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha3

import (
	v1alpha3 "github.com/fluxcd/flagger/pkg/apis/smi/v1alpha3"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/listers"
	"k8s.io/client-go/tools/cache"
)

// TrafficSplitLister helps list TrafficSplits.
// All objects returned here must be treated as read-only.
type TrafficSplitLister interface {
	// List lists all TrafficSplits in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha3.TrafficSplit, err error)
	// TrafficSplits returns an object that can list and get TrafficSplits.
	TrafficSplits(namespace string) TrafficSplitNamespaceLister
	TrafficSplitListerExpansion
}

// trafficSplitLister implements the TrafficSplitLister interface.
type trafficSplitLister struct {
	listers.ResourceIndexer[*v1alpha3.TrafficSplit]
}

// NewTrafficSplitLister returns a new TrafficSplitLister.
func NewTrafficSplitLister(indexer cache.Indexer) TrafficSplitLister {
	return &trafficSplitLister{listers.New[*v1alpha3.TrafficSplit](indexer, v1alpha3.Resource("trafficsplit"))}
}

// TrafficSplits returns an object that can list and get TrafficSplits.
func (s *trafficSplitLister) TrafficSplits(namespace string) TrafficSplitNamespaceLister {
	return trafficSplitNamespaceLister{listers.NewNamespaced[*v1alpha3.TrafficSplit](s.ResourceIndexer, namespace)}
}

// TrafficSplitNamespaceLister helps list and get TrafficSplits.
// All objects returned here must be treated as read-only.
type TrafficSplitNamespaceLister interface {
	// List lists all TrafficSplits in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha3.TrafficSplit, err error)
	// Get retrieves the TrafficSplit from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha3.TrafficSplit, error)
	TrafficSplitNamespaceListerExpansion
}

// trafficSplitNamespaceLister implements the TrafficSplitNamespaceLister
// interface.
type trafficSplitNamespaceLister struct {
	listers.ResourceIndexer[*v1alpha3.TrafficSplit]
}
